Bug 1465885 - Review Request: golang-github-cznic-golex - Lex/Flex-like utility written in Go
Review Request: golang-github-cznic-golex - Lex/Flex-like utility written in Go
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Athos Ribeiro
Fedora Extras Quality Assurance
:
Depends On: 1465881 1465884
Blocks: 1431748
  Show dependency treegraph
 
Reported: 2017-06-28 08:19 EDT by Fabio Valentini
Modified: 2017-08-02 16:51 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2017-08-02 12:49:51 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
athoscribeiro: fedora‑review+


Attachments (Terms of Use)

  None (edit)
Description Fabio Valentini 2017-06-28 08:19:58 EDT
Spec URL: https://decathorpe.fedorapeople.org/packages/golang-github-cznic-golex.spec

SRPM URL: https://decathorpe.fedorapeople.org/packages/golang-github-cznic-golex-0-0.1.20170310.gitd7f6f2b.fc26.src.rpm

Description: Lex/Flex-like utility written in Go. This package is one of the new dependencies of one of my other requested packages.

Fedora Account System Username: decathorpe


Since not all dependencies are present in fedora yet, a successful COPR build can be seen here: https://copr.fedorainfracloud.org/coprs/decathorpe/golang-staging/build/571622/
Comment 1 Athos Ribeiro 2017-07-23 22:48:30 EDT
Hi Fabio, I am taking this one.

- The main package should ship the license file (and maybe the docs as well).

- calc/calc.y has a different license, but is not present in the binary package. There is a license file for it in the sources, so no action should be needed here.

- Since this is a binary program, you could consider either renaming the package to golex, as indicated in the guidelines [1], or adding a Provides for it (this is up to you though, just thought it was worth mentioning).

- Is there any reason for not building a debuginfo package? Note that there is a --build option in gofed.

- rpmlint triggers:
  golang-github-cznic-golex.x86_64: W: unstripped-binary-or-object /usr/bin/golex
  (you probably want to chmod 0755 the binary file)

[1] https://fedoraproject.org/wiki/PackagingDrafts/Go#Packaging_Binaries
[2] https://fedoraproject.org/wiki/PackagingDrafts/Go#Debuginfo

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated

===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
[!]: License file installed when any subpackage combination is installed.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[!]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
[!]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
[?]: Package functions as described.
[!]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: golang-github-cznic-golex-0-0.1.20170310.gitd7f6f2b.fc27.x86_64.rpm
          golang-github-cznic-golex-devel-0-0.1.20170310.gitd7f6f2b.fc27.noarch.rpm
          golang-github-cznic-golex-unit-test-devel-0-0.1.20170310.gitd7f6f2b.fc27.x86_64.rpm
          golang-github-cznic-golex-0-0.1.20170310.gitd7f6f2b.fc27.src.rpm
golang-github-cznic-golex.x86_64: W: spelling-error Summary(en_US) Lex -> Le, Ex, Lee
golang-github-cznic-golex.x86_64: W: spelling-error %description -l en_US Lex -> Le, Ex, Lee
golang-github-cznic-golex.x86_64: W: unstripped-binary-or-object /usr/bin/golex
golang-github-cznic-golex.x86_64: W: only-non-binary-in-usr-lib
golang-github-cznic-golex.x86_64: W: no-documentation
golang-github-cznic-golex.x86_64: W: hidden-file-or-dir /usr/lib/.build-id
golang-github-cznic-golex.x86_64: W: hidden-file-or-dir /usr/lib/.build-id
golang-github-cznic-golex.x86_64: W: no-manual-page-for-binary golex
golang-github-cznic-golex-devel.noarch: W: spelling-error Summary(en_US) Lex -> Le, Ex, Lee
golang-github-cznic-golex-devel.noarch: W: spelling-error %description -l en_US Lex -> Le, Ex, Lee
golang-github-cznic-golex.src: W: spelling-error Summary(en_US) Lex -> Le, Ex, Lee
golang-github-cznic-golex.src: W: spelling-error %description -l en_US Lex -> Le, Ex, Lee
4 packages and 0 specfiles checked; 0 errors, 12 warnings.




Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: No such file or directory
golang-github-cznic-golex.x86_64: W: spelling-error Summary(en_US) Lex -> Le, Ex, Lee
golang-github-cznic-golex.x86_64: W: spelling-error %description -l en_US Lex -> Le, Ex, Lee
golang-github-cznic-golex.x86_64: W: unstripped-binary-or-object /usr/bin/golex
golang-github-cznic-golex.x86_64: W: only-non-binary-in-usr-lib
golang-github-cznic-golex.x86_64: W: no-documentation
golang-github-cznic-golex.x86_64: W: no-manual-page-for-binary golex
golang-github-cznic-golex-devel.noarch: W: spelling-error Summary(en_US) Lex -> Le, Ex, Lee
golang-github-cznic-golex-devel.noarch: W: spelling-error %description -l en_US Lex -> Le, Ex, Lee
3 packages and 0 specfiles checked; 0 errors, 8 warnings.



Requires
--------
golang-github-cznic-golex-unit-test-devel (rpmlib, GLIBC filtered):
    golang-github-cznic-golex-devel

golang-github-cznic-golex (rpmlib, GLIBC filtered):
    libc.so.6()(64bit)
    rtld(GNU_HASH)

golang-github-cznic-golex-devel (rpmlib, GLIBC filtered):



Provides
--------
golang-github-cznic-golex-unit-test-devel:
    golang-github-cznic-golex-unit-test-devel
    golang-github-cznic-golex-unit-test-devel(x86-64)

golang-github-cznic-golex:
    golang-github-cznic-golex
    golang-github-cznic-golex(x86-64)

golang-github-cznic-golex-devel:
    golang(github.com/cznic/golex/lex)
    golang-github-cznic-golex-devel



Source checksums
----------------
https://github.com/cznic/golex/archive/d7f6f2b7a35fa282b3d64161aefe00efb3d56d14/cznic-golex-d7f6f2b.tar.gz :
  CHECKSUM(SHA256) this package     : 1e570dacf3875b6c8e1253aa82fe4f34352555d5f3848e91c328439de92ab12a
  CHECKSUM(SHA256) upstream package : 1e570dacf3875b6c8e1253aa82fe4f34352555d5f3848e91c328439de92ab12a
Comment 2 Fabio Valentini 2017-07-24 09:57:44 EDT
I think I've addressed all the issues with the new .spec and SRPM file.

- License and docs are also installed with the binary package.
- Added "Provides: golex = VERSION" to the binary package.
- Debuginfo package is built (forgot to flip the switch in line 6, stupid me).

Since the "calc" folder only contains yet another usage example (which isn't shipped and/or used for building the package), I'll just ignore it for packaging (and licensing).

Spec URL: https://decathorpe.fedorapeople.org/packages/golang-github-cznic-golex.spec

SRPM URL: https://decathorpe.fedorapeople.org/packages/golang-github-cznic-golex-0-0.1.20170310.gitd7f6f2b.fc26.1.src.rpm
Comment 3 Athos Ribeiro 2017-07-24 10:19:36 EDT
Hi Fabio,

I just realized that your Release tag has a '.1' appended to it. Is there a reason for using the minorbump [1] here?

The pointed issues are fixed and the package looks good now. Approved.

[1] https://fedoraproject.org/wiki/Packaging:Versioning#You_need_to_change_an_old_branch_without_rebuilding_the_others
Comment 4 Fabio Valentini 2017-07-24 10:36:02 EDT
Damn. It seems I misunderstood the versioning guidelines. I just wanted to bump the release for the changes I made according to your review, but well ...

I'll fix it before importing (sorry for the confusion - I'm on painkillers right now).

And thank you for the review!
Comment 5 Gwyn Ciesla 2017-07-24 10:48:12 EDT
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/rpms/golang-github-cznic-golex
Comment 6 Fedora Update System 2017-07-25 04:32:50 EDT
golang-github-cznic-golex-0-0.1.20170310.gitd7f6f2b.fc26 has been submitted as an update to Fedora 26. https://bodhi.fedoraproject.org/updates/FEDORA-2017-620799a3ad
Comment 7 Fedora Update System 2017-07-25 18:54:22 EDT
golang-github-cznic-golex-0-0.1.20170310.gitd7f6f2b.fc25 has been pushed to the Fedora 25 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-ca7fe7ae40
Comment 8 Fedora Update System 2017-07-25 21:19:23 EDT
golang-github-cznic-golex-0-0.1.20170310.gitd7f6f2b.fc26 has been pushed to the Fedora 26 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-620799a3ad
Comment 9 Fedora Update System 2017-08-02 12:49:51 EDT
golang-github-cznic-golex-0-0.1.20170310.gitd7f6f2b.fc26 has been pushed to the Fedora 26 stable repository. If problems still persist, please make note of it in this bug report.
Comment 10 Fedora Update System 2017-08-02 16:51:14 EDT
golang-github-cznic-golex-0-0.1.20170310.gitd7f6f2b.fc25 has been pushed to the Fedora 25 stable repository. If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.